/*
 * ExperimentC.h - Simple experiment manager.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 17-Jun-1998
 *
 */

#ifndef ExperimentC_h
#define ExperimentC_h 1

#include "ExperimentA.h"

#include "ProblemC.h"

#include <Common/StringC.h>
#include <Common/RandomC.h>

class ExperimentC: public ExperimentA
{
	public:

		ExperimentC
		(
			ConfigurationA const & iConfiguration,
			StatisticsA & iStatistics,
			CoreFactoryA const & iCoreFactory,
			ProblemFactoryA const & iProblemFactory,
			ReproductionFactoryA const & iReproductionFactory,
			RandomA & iRandom
		);

		virtual ~ExperimentC();

		virtual void Run();

	protected:

		EvolutionaryAlgorithmA * EvolutionaryAlgorithm;

		ProblemA * Problem;

	private:

}; // ExperimentC

#endif

// Eof ExperimentC.h
