/*
 * ClassificationC.h - A simple fitness function implementation.
 *
 * Part of the Evolutionary Algorithm Library.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 06-Aug-1998
 *
 */

#ifndef ClassificationC_h
#define ClassificationC_h 1

#include <Problem/FitnessFunctionA.h>

#include "DataBaseProblemC.h"
#include "TreeDataC.h"
//#include <Problem/ProblemFactoryA.h>
#include <Error/LibraryErrorC.h>
#include <StatisticsA.h>

class ClassificationC: public FitnessFunctionA
{
	public:

		ClassificationC
		(
			ConfigurationA const & iConfiguration,
			StatisticsA & iStatistics,
			StopConditionA const & iStopCondition,
			ProblemA const & iProblem
		);

		virtual ~ClassificationC();

		virtual void const Calculate
		(
			FitnessType & iFitnessValue,
			DataA const & iData
		) const;

	protected:

		DataBaseProblemC const * DataBaseProblem;

	private:

}; // ClassificationC

#endif

// Eof ClassificationC.h
