/*
 * ProblemA.h - A base class for the problem class.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 08-Jun-1998
 *
 */

#ifndef ProblemA_h
#define ProblemA_h 1

class DataA;
class ConfigurationA;

class ProblemA 
{
	public:

		virtual ~ProblemA () =0;

		virtual void Produce() =0;

		virtual bool IsSolution
		(
			DataA const & iData
		) const =0;

		//TODO: Next memberfunction isn't general and should be handled different.
		virtual bool Evaluate
		(
			unsigned int iVariable1,
			unsigned int iVariable2,
			unsigned int iValue1,
			unsigned int iValue2
		) const =0;

	protected:

		ProblemA
		(
			ConfigurationA const & iConfiguration
		): Configuration(iConfiguration)
		{};

		ConfigurationA const & Configuration;

	private:

}; // ProblemA

#endif

// Eof ProblemA.h
