/*
 * ProblemFactoryC.h - Abstract base class for instantiating objects within the Fitness package.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 18-Jun-1998
 *
 */

#ifndef ProblemFactoryC_h
#define ProblemFactoryC_h 1

#include "Problem/ProblemFactoryA.h"

//#include "Problem/FitnessValueC.h"
#include "Problem/FitnessFunctionC.h"
#include "Problem/DataC.h"


class ProblemFactoryC: public ProblemFactoryA
{
	public:

		ProblemFactoryC
		(
			ConfigurationA const & iConfiguration
		): ProblemFactoryA(iConfiguration)
		{};

		virtual ~ProblemFactoryC()
		{};

		//virtual FitnessValueA* CreateFitnessValue() const;

		virtual FitnessFunctionA* CreateFitnessFunction
		(
			StopConditionA const & iStopCondition,
			StatisticsA & iStatistics,
			ProblemA const & iProblem
		) const;

		virtual DataA* CreateData
		(
			unsigned int iSize
		) const;

	protected:

	private:

}; // ProblemFactoryC

#endif

// Eof ProblemFactoryC.h
