/*
 * ExceptionA.cc - Abstract base class for an initialization object.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 24-May-1998
 *
 */

#include "Error/ExceptionA.h"


//TODO: Check if supporting StringC in ctor for ExceptionA is needed/recommended.
/*
ExceptionA::ExceptionA
(
	StringC const & iString
)
{
	Message = new StringC(iString);
};
*/



ExceptionA::ExceptionA
(
	char const * iChar
)
{
	Message = new StringC(iChar);
};




ExceptionA::~ExceptionA()
{
	delete Message;

} // ~ExceptionA


void
ExceptionA::PrintMessage() const
{
	cerr << *Message << endl;
}

// Eof ExceptionA.cc
