/*
 * testStringC.cc - Tests the StringC class.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 14-May-1998
 *
 */

#include "testStringC.h"

//-----------------------------------------

void String6c()
{
	cerr << "string+string: ";

	StringC a;
	StringC b("pas");
	StringC c("sed");
	a = b + c;

	cerr << a << "\n";
}


void String6b()
{
	cerr << "char*+string: ";

	StringC a;
	StringC b("sed");
	a = "pas" + b;

	cerr << a << "\n";
}

void String6a()
{
	cerr << "string+char*: ";

	StringC a;
	StringC b("pas");
	a = b + "sed";

	cerr << a << "\n";
}

//-----------------------------------------

void String5b()
{
	cerr << "string+=string: ";

	StringC c("sed");
	StringC a("pas");
	a += c;

	cerr << a << "\n";
}


void String5a()
{
	cerr << "string+=char*: ";

	StringC a("pas");
	a += "sed";

	cerr << a << "\n";
}

//-----------------------------------------

void String4c()
{
	cerr << "string!=string (1): ";

	StringC c("not ok");

	StringC a("passed");
	if (a != c)
		cerr << "ok\n";
	else
		cerr << "fail\n";

	cerr << "string!=string (2): ";

	StringC b("not ok");
	if (b != c)
		cerr << "fail\n";
	else
		cerr << "ok\n";
}


void String4b()
{
	cerr << "char*!=string (1): ";

	StringC a("passed");
	if ("not ok" != a)
		cerr << "ok\n";
	else
		cerr << "fail\n";

	cerr << "char*!=string (2): ";

	StringC b("not ok");
	if ("not ok"!= b)
		cerr << "fail\n";
	else
		cerr << "ok\n";
}

void String4a()
{
	cerr << "string!=char* (1): ";

	StringC a("passed");
	if (a != "not ok")
		cerr << "ok\n";
	else
		cerr << "fail\n";

	cerr << "string!=char* (2): ";

	StringC b("not ok");
	if (b != "not ok")
		cerr << "fail\n";
	else
		cerr << "ok\n";
}

//-----------------------------------------

void String3c()
{
	cerr << "string==string (1): ";

	StringC c("passed");

	StringC a("passed");
	if (a == c)
		cerr << "ok\n";
	else
		cerr << "fail\n";

	cerr << "string==string (2): ";

	StringC b("not ok");
	if (b == c)
		cerr << "fail\n";
	else
		cerr << "ok\n";
}


void String3b()
{
	cerr << "char*==string (1): ";

	StringC a("passed");
	if ("passed" == a)
		cerr << "ok\n";
	else
		cerr << "fail\n";

	cerr << "char*==string (2): ";

	StringC b("not ok");
	if ("passed" == b)
		cerr << "fail\n";
	else
		cerr << "ok\n";
}

void String3a()
{
	cerr << "string==char* (1): ";

	StringC a("passed");
	if (a == "passed")
		cerr << "ok\n";
	else
		cerr << "fail\n";

	cerr << "string==char* (2): ";

	StringC b("not ok");
	if (b == "passed")
		cerr << "fail\n";
	else
		cerr << "ok\n";
}

//-----------------------------------------

void String2b()
{
	cerr << "string=string: ";

	StringC a("fail");
	StringC b("passed");
	a = b;

	cerr << a << "\n";
}


void String2a()
{
	cerr << "string=char*: ";

	StringC a;
	a = "passed";

	cerr << a << "\n";
}

//-----------------------------------------

void String1b()
{
	cerr << "copy constructor (string): ";

	StringC a("passed");
	StringC b(a);

	cerr << b << "\n";
}



void String1a()
{
	cerr << "copy constructor (char*): ";

	StringC a("passed");

	cerr << a << "\n";
}

//-----------------------------------------

void String0()
{
	StringC * a;

	cerr << "constructor/destructor: ";
	a = new StringC();
	delete a;

	cerr << "ok\n";
}


int testStringC()
{
	cerr << "<testing StringC>\n";
	String0();
	String1a();
	String1b();
	String2a();
	String2b();
	String3a();
	String3b();
	String3c();
	String4a();
	String4b();
	String4c();
	String5a();
	String5b();
	String6a();
	String6b();
	String6c();

	return 0;
}
